security:
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'

    #############################################################################
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email
    #############################################################################
    #  https://symfony.com/doc/current/reference/configuration/security.html#session-fixation-strategy
    session_fixation_strategy: invalidate
    #    When authenticating users, the entire session is regenerated,
    #    so the session ID is updated and all the other session attributes are lost.
    #############################################################################
    role_hierarchy:
        ROLE_CERTIFICAT_MANAGER:
            - ROLE_USER
        ROLE_ADMIN:
            - ROLE_CERTIFICAT_MANAGER
            - ROLE_ALLOWED_TO_SWITCH
    #############################################################################
    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/admin,                        roles: ROLE_ADMIN }
        - { path: ^/cert-manager,                 roles: ROLE_CERTIFICAT_MANAGER }
        - { path: ^/user/profile,                 roles: ROLE_USER }
#       - { path: ^/user/certificates,            roles: ROLE_USER }
        - { path: ^/poc,                          roles: PUBLIC_ACCESS }
#       - { path: ^/,                             roles: PUBLIC_ACCESS }
#       - { path: ^/health-check,                 roles: PUBLIC_ACCESS }
#       - { path: ^/account/login,                roles: PUBLIC_ACCESS }
#       - { path: ^/account/logout,               roles: PUBLIC_ACCESS }

    #############################################################################
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false
        main:
            lazy: true
            provider: app_user_provider
            logout:
                path: 'app_account_logout'
                target: 'app_home'
                # Send [ Clear-Site-Data ] HTTP Header to clears browsing data
                #       https://symfony.com/doc/current/reference/configuration/security.html#clear-site-data
                #       https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Clear-Site-Data
                clear_site_data:
                    - cookies
                    - storage
#                   - executionContexts
#                   - cache
            form_login:
                enable_csrf: true
                form_only: true # checks that the request content-type is application/x-www-form-urlencoded
                always_use_default_target_path: false
                login_path: 'app_account_login'
                check_path: 'app_account_login'
#               rate_limiter:
#               login_throttling:
#               switch_user: true

########### login_throttling
# configure the maximum login attempts
# by default, the feature allows 5 login attempts per minute
#               login_throttling: null
#               login_throttling:
#                   max_attempts: 3        # by default, the feature allows 5 login attempts per minute
#                 # interval: '15 minutes' # ... or in a custom period

###########  switch_user
# https://symfony.com/doc/current/security/impersonating_user.html
#               switch_user: true

###########  activate different ways to authenticate
# https://symfony.com/doc/current/security.html#the-firewall

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
